<?php

namespace FiloBlu\MappConnectorExtension\Observer;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

/**
 * Class MappAdditionalData
 * @package FiloBlu\Newsletter\Observer
 */
class MappAdditionalData implements ObserverInterface
{

    /**
     * @var \FiloBlu\Newsletter\Model\SubscriberInfo
     */
    protected $_subscriberInfo;

    /**
     * MappAdditionalData constructor.
     * @param \FiloBlu\Newsletter\Model\SubscriberInfo $subscriberInfo
     */
    public function __construct(
        \FiloBlu\Newsletter\Model\SubscriberInfo $subscriberInfo
    )
    {
        $this->_subscriberInfo = $subscriberInfo;
    }

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        try {
            $subscriber_object = $observer->getResult();
            $result = $subscriber_object->getSubscriberData();
            $subinfo = clone $this->_subscriberInfo;

            $nl_additional_data = [
                "subscriber_id" => '',
                "firstname" => '',
                "lastname" => '',
                "dob" => '',
                "country" => '',
                "gender" => '',
                "collections" => '',
                "source" => '',
                "language" => '',
                "website_name" => '',
                "birthday" => '',
                "phone" => '',
                "created_at" => '',
                "updated_at" => ''
            ];

            $newsletter_additional_data = $subinfo->load($result['subscriberid']);
            if(count($newsletter_additional_data->getData())>0){
                $nl_additional_data = $newsletter_additional_data->getData();
                $nl_additional_data['dob'] = date('Y-m-d', strtotime($nl_additional_data['dob'].' 00:00:00'));
                $lan = explode('_',$nl_additional_data['language']);
                $nl_additional_data['language'] = $lan[0];
            }
            $result = array_merge($result,$nl_additional_data);

            unset(
                $result['subscriber_id'],
                $result['subscriberid']
            );

            $subscriber_object->setSubscriberData($result);
        }
        catch (\Exception $e){

        }

    }

}